// Chemfiles, a modern library for chemistry file reading and writing
// Copyright (C) Guillaume Fraux and contributors -- BSD license

// !!!! AUTO-GENERATED FILE !!!! Do not edit. See elements.py for the code.
// The data comes from Blue Obelisk's data repository at the svn repository:
// http://svn.code.sf.net/p/bodr/code/trunk/bodr

#include "chemfiles/periodic_table.hpp"
using namespace chemfiles;

const atomic_data_map chemfiles::PERIODIC_TABLE = {
    {"Xx", {0, std::string("Dummy"), 0.0, nullopt, 0.0, 0.0}},
    {"H", {1, std::string("Hydrogen"), 1.008, nullopt, 0.37, 1.2}},
    {"He", {2, std::string("Helium"), 4.002602, nullopt, 0.32, 1.4}},
    {"Li", {3, std::string("Lithium"), 6.94, nullopt, 1.34, 2.2}},
    {"Be", {4, std::string("Beryllium"), 9.012182, nullopt, 0.9, 1.9}},
    {"B", {5, std::string("Boron"), 10.81, nullopt, 0.82, 1.8}},
    {"C", {6, std::string("Carbon"), 12.011, nullopt, 0.77, 1.7}},
    {"N", {7, std::string("Nitrogen"), 14.007, nullopt, 0.75, 1.6}},
    {"O", {8, std::string("Oxygen"), 15.999, nullopt, 0.73, 1.55}},
    {"F", {9, std::string("Fluorine"), 18.9984032, nullopt, 0.71, 1.5}},
    {"Ne", {10, std::string("Neon"), 20.1797, nullopt, 0.69, 1.54}},
    {"Na", {11, std::string("Sodium"), 22.98976928, nullopt, 1.54, 2.4}},
    {"Mg", {12, std::string("Magnesium"), 24.305, nullopt, 1.3, 2.2}},
    {"Al", {13, std::string("Aluminium"), 26.9815386, nullopt, 1.18, 2.1}},
    {"Si", {14, std::string("Silicon"), 28.085, nullopt, 1.11, 2.1}},
    {"P", {15, std::string("Phosphorus"), 30.973762, nullopt, 1.06, 1.95}},
    {"S", {16, std::string("Sulfur"), 32.06, nullopt, 1.02, 1.8}},
    {"Cl", {17, std::string("Chlorine"), 35.45, nullopt, 0.99, 1.8}},
    {"Ar", {18, std::string("Argon"), 39.948, nullopt, 0.97, 1.88}},
    {"K", {19, std::string("Potassium"), 39.0983, nullopt, 1.96, 2.8}},
    {"Ca", {20, std::string("Calcium"), 40.078, nullopt, 1.74, 2.4}},
    {"Sc", {21, std::string("Scandium"), 44.955912, nullopt, 1.44, 2.3}},
    {"Ti", {22, std::string("Titanium"), 47.867, nullopt, 1.36, 2.15}},
    {"V", {23, std::string("Vanadium"), 50.9415, nullopt, 1.25, 2.05}},
    {"Cr", {24, std::string("Chromium"), 51.9961, nullopt, 1.27, 2.05}},
    {"Mn", {25, std::string("Manganese"), 54.938045, nullopt, 1.39, 2.05}},
    {"Fe", {26, std::string("Iron"), 55.845, nullopt, 1.25, 2.05}},
    {"Co", {27, std::string("Cobalt"), 58.933195, nullopt, 1.26, 2.0}},
    {"Ni", {28, std::string("Nickel"), 58.6934, nullopt, 1.21, 2.0}},
    {"Cu", {29, std::string("Copper"), 63.546, nullopt, 1.38, 2.0}},
    {"Zn", {30, std::string("Zinc"), 65.38, nullopt, 1.31, 2.1}},
    {"Ga", {31, std::string("Gallium"), 69.723, nullopt, 1.26, 2.1}},
    {"Ge", {32, std::string("Germanium"), 72.63, nullopt, 1.22, 2.1}},
    {"As", {33, std::string("Arsenic"), 74.9216, nullopt, 1.19, 2.05}},
    {"Se", {34, std::string("Selenium"), 78.96, nullopt, 1.16, 1.9}},
    {"Br", {35, std::string("Bromine"), 79.904, nullopt, 1.14, 1.9}},
    {"Kr", {36, std::string("Krypton"), 83.798, nullopt, 1.1, 2.02}},
    {"Rb", {37, std::string("Rubidium"), 85.4678, nullopt, 2.11, 2.9}},
    {"Sr", {38, std::string("Strontium"), 87.62, nullopt, 1.92, 2.55}},
    {"Y", {39, std::string("Yttrium"), 88.90585, nullopt, 1.62, 2.4}},
    {"Zr", {40, std::string("Zirconium"), 91.224, nullopt, 1.48, 2.3}},
    {"Nb", {41, std::string("Niobium"), 92.90638, nullopt, 1.37, 2.15}},
    {"Mo", {42, std::string("Molybdenum"), 95.96, nullopt, 1.45, 2.1}},
    {"Tc", {43, std::string("Technetium"), 97.0, nullopt, 1.56, 2.05}},
    {"Ru", {44, std::string("Ruthenium"), 101.07, nullopt, 1.26, 2.05}},
    {"Rh", {45, std::string("Rhodium"), 102.9055, nullopt, 1.35, 2.0}},
    {"Pd", {46, std::string("Palladium"), 106.42, nullopt, 1.31, 2.05}},
    {"Ag", {47, std::string("Silver"), 107.8682, nullopt, 1.53, 2.1}},
    {"Cd", {48, std::string("Cadmium"), 112.411, nullopt, 1.48, 2.2}},
    {"In", {49, std::string("Indium"), 114.818, nullopt, 1.44, 2.2}},
    {"Sn", {50, std::string("Tin"), 118.71, nullopt, 1.41, 2.25}},
    {"Sb", {51, std::string("Antimony"), 121.76, nullopt, 1.38, 2.2}},
    {"Te", {52, std::string("Tellurium"), 127.6, nullopt, 1.35, 2.1}},
    {"I", {53, std::string("Iodine"), 126.90447, nullopt, 1.33, 2.1}},
    {"Xe", {54, std::string("Xenon"), 131.293, nullopt, 1.3, 2.16}},
    {"Cs", {55, std::string("Caesium"), 132.9054519, nullopt, 2.25, 3.0}},
    {"Ba", {56, std::string("Barium"), 137.327, nullopt, 1.98, 2.7}},
    {"La", {57, std::string("Lanthanum"), 138.90547, nullopt, 1.69, 2.5}},
    {"Ce", {58, std::string("Cerium"), 140.116, nullopt, 1.69, 2.48}},
    {"Pr", {59, std::string("Praseodymium"), 140.90765, nullopt, 1.69, 2.47}},
    {"Nd", {60, std::string("Neodymium"), 144.242, nullopt, 1.69, 2.45}},
    {"Pm", {61, std::string("Promethium"), 145.0, nullopt, 1.69, 2.43}},
    {"Sm", {62, std::string("Samarium"), 150.36, nullopt, 1.69, 2.42}},
    {"Eu", {63, std::string("Europium"), 151.964, nullopt, 1.69, 2.4}},
    {"Gd", {64, std::string("Gadolinium"), 157.25, nullopt, 1.69, 2.38}},
    {"Tb", {65, std::string("Terbium"), 158.92535, nullopt, 1.69, 2.37}},
    {"Dy", {66, std::string("Dysprosium"), 162.5, nullopt, 1.69, 2.35}},
    {"Ho", {67, std::string("Holmium"), 164.93032, nullopt, 1.69, 2.33}},
    {"Er", {68, std::string("Erbium"), 167.259, nullopt, 1.69, 2.32}},
    {"Tm", {69, std::string("Thulium"), 168.93421, nullopt, 1.69, 2.3}},
    {"Yb", {70, std::string("Ytterbium"), 173.054, nullopt, 1.69, 2.28}},
    {"Lu", {71, std::string("Lutetium"), 174.9668, nullopt, 1.6, 2.27}},
    {"Hf", {72, std::string("Hafnium"), 178.49, nullopt, 1.5, 2.25}},
    {"Ta", {73, std::string("Tantalum"), 180.94788, nullopt, 1.38, 2.2}},
    {"W", {74, std::string("Tungsten"), 183.84, nullopt, 1.46, 2.1}},
    {"Re", {75, std::string("Rhenium"), 186.207, nullopt, 1.59, 2.05}},
    {"Os", {76, std::string("Osmium"), 190.23, nullopt, 1.28, 2.0}},
    {"Ir", {77, std::string("Iridium"), 192.217, nullopt, 1.37, 2.0}},
    {"Pt", {78, std::string("Platinum"), 195.084, nullopt, 1.28, 2.05}},
    {"Au", {79, std::string("Gold"), 196.966569, nullopt, 1.44, 2.1}},
    {"Hg", {80, std::string("Mercury"), 200.592, nullopt, 1.49, 2.05}},
    {"Tl", {81, std::string("Thallium"), 204.38, nullopt, 1.48, 2.2}},
    {"Pb", {82, std::string("Lead"), 207.2, nullopt, 1.47, 2.3}},
    {"Bi", {83, std::string("Bismuth"), 208.9804, nullopt, 1.46, 2.3}},
    {"Po", {84, std::string("Polonium"), 209.0, nullopt, 1.46, 2.0}},
    {"At", {85, std::string("Astatine"), 210.0, nullopt, 1.46, 2.0}},
    {"Rn", {86, std::string("Radon"), 222.0, nullopt, 1.45, 2.0}},
    {"Fr", {87, std::string("Francium"), 223.0, nullopt, 1.45, 2.0}},
    {"Ra", {88, std::string("Radium"), 226.0, nullopt, 1.45, 2.0}},
    {"Ac", {89, std::string("Actinium"), 227.0, nullopt, 1.45, 2.0}},
    {"Th", {90, std::string("Thorium"), 232.03806, nullopt, 1.45, 2.4}},
    {"Pa", {91, std::string("Protactinium"), 231.03588, nullopt, 1.45, 2.0}},
    {"U", {92, std::string("Uranium"), 238.02891, nullopt, 1.45, 2.3}},
    {"Np", {93, std::string("Neptunium"), 237.0, nullopt, 1.45, 2.0}},
    {"Pu", {94, std::string("Plutonium"), 244.0, nullopt, 1.45, 2.0}},
    {"Am", {95, std::string("Americium"), 243.0, nullopt, 1.45, 2.0}},
    {"Cm", {96, std::string("Curium"), 247.0, nullopt, 1.45, 2.0}},
    {"Bk", {97, std::string("Berkelium"), 247.0, nullopt, 1.45, 2.0}},
    {"Cf", {98, std::string("Californium"), 251.0, nullopt, 1.45, 2.0}},
    {"Es", {99, std::string("Einsteinium"), 252.0, nullopt, 1.45, 2.0}},
    {"Fm", {100, std::string("Fermium"), 257.0, nullopt, 1.45, 2.0}},
    {"Md", {101, std::string("Mendelevium"), 258.0, nullopt, 1.45, 2.0}},
    {"No", {102, std::string("Nobelium"), 259.0, nullopt, 1.45, 2.0}},
    {"Lr", {103, std::string("Lawrencium"), 262.0, nullopt, 1.45, 2.0}},
    {"Rf", {104, std::string("Rutherfordium"), 267.0, nullopt, 1.45, 2.0}},
    {"Db", {105, std::string("Dubnium"), 270.0, nullopt, 1.45, 2.0}},
    {"Sg", {106, std::string("Seaborgium"), 271.0, nullopt, 1.45, 2.0}},
    {"Bh", {107, std::string("Bohrium"), 270.0, nullopt, 1.45, 2.0}},
    {"Hs", {108, std::string("Hassium"), 277.0, nullopt, 1.45, 2.0}},
    {"Mt", {109, std::string("Meitnerium"), 276.0, nullopt, 1.45, 2.0}},
    {"Ds", {110, std::string("Darmstadtium"), 281.0, nullopt, 1.45, 2.0}},
    {"Rg", {111, std::string("Roentgenium"), 282.0, nullopt, 1.45, 2.0}},
    {"Cn", {112, std::string("Copernicium"), 285.0, nullopt, 1.45, 2.0}},
    {"Uut", {113, std::string("Ununtrium"), 285.0, nullopt, 1.45, 2.0}},
    {"Fl", {114, std::string("Flerovium"), 289.0, nullopt, 1.45, 2.0}},
    {"Uup", {115, std::string("Ununpentium"), 289.0, nullopt, 1.45, 2.0}},
    {"Lv", {116, std::string("Livermorium"), 293.0, nullopt, 1.45, 2.0}},
    {"Uus", {117, std::string("Ununseptium"), 294.0, nullopt, 1.45, 2.0}},
    {"Uuo", {118, std::string("Ununoctium"), 294.0, nullopt, 1.45, 2.0}},
};
